SystemOrganization addCategory: #IRCBot3!
SystemOrganization addCategory: #'IRCBot3-Tests'!
SystemOrganization addCategory: #'IRCBot3-Core'!
SystemOrganization addCategory: #'IRCBot3-Handlers'!
SystemOrganization addCategory: #'IRCBot3-Client'!
SystemOrganization addCategory: #'IRCBot3-Website'!

Object subclass: #AbstractRegex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Core'!

!AbstractRegex commentStamp: 'FS 7/1/2008 13:42' prior: 0!
This class provides a simple regex interface. 
Subclass it to use your favorite Regex engine.!

!AbstractRegex class methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 15:11'!
forString: aString
	^self newForPattern: aString.! !

!AbstractRegex class methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 15:11'!
newForPattern: aPattern
	self subclassResponsibility.! !

!AbstractRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 11:52'!
matchAt: anIndex
	"should answer the captured text i.e., text inside parentheses"
	self subclassResponsibility! !

!AbstractRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 11:51'!
matches: aString
	"should answer true / false"
	self subclassResponsibility! !

!AbstractRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/8/2008 13:34'!
pattern
	"the pattern as a string "
	self subclassResponsibility! !

!AbstractRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 13:40'!
pattern: aString
	"should store/compile the pattern "
	self subclassResponsibility! !

!AbstractRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/8/2008 11:53'!
setCaseInsensitive
	"should store/compile the pattern "
	self subclassResponsibility! !

AbstractRegex subclass: #ReRegex
	instanceVariableNames: 're reMatch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Core'!

!ReRegex commentStamp: 'FS 7/8/2008 11:35' prior: 0!
Abstract the behaviour of the RePlugin (see the Regex package)
Look at the test case to have an overview of the behaviour!

!ReRegex class methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 14:29'!
newForPattern: aPattern
	^self new re: aPattern asRegex.! !

!ReRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/3/2008 16:31'!
matchAt: anIndex
	"before getting the submatch, you must send matches:" 		
	((reMatch isNil not) and: [ anIndex <= self numberOfMatches])
		ifTrue: [^ reMatch matchAt: anIndex]
		ifFalse: [^ nil]
		! !

!ReRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 14:18'!
matches: aString 
	"Does the string match the pattern?"
	self reMatch: (re search: aString).
	^self reMatch isNil not.! !

!ReRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/3/2008 16:00'!
numberOfMatches
	"number of captured substrings"
	reMatch 
		ifNil: [^ 0]
		ifNotNil: [^ reMatch numGroups]! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/7/2008 21:08'!
pattern
	"gives the pattern as a string (not compiled)"
	^ self re pattern.! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/1/2008 13:50'!
pattern: aString 
	self re pattern: aString.
	self re compile.! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/1/2008 13:49'!
re
	^ re! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/1/2008 13:49'!
re: anObject
	re := anObject! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/1/2008 14:18'!
reMatch
	^ reMatch! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/1/2008 14:18'!
reMatch: anObject
	reMatch := anObject! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/8/2008 11:54'!
setCaseInsensitive
	self re setOptionForPCRECharacter: $i to: true! !

Object subclass: #AdminCommand
	instanceVariableNames: 'methodSymbol regex shortHelp longHelp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
longHelp
	^ longHelp! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
longHelp: anObject
	longHelp := anObject! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
methodSymbol
	^ methodSymbol! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
methodSymbol: anObject
	methodSymbol := anObject! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
regex
	^ regex! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
regex: anObject
	regex := anObject! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
shortHelp
	^ shortHelp! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
shortHelp: anObject
	shortHelp := anObject! !

Object subclass: #BotHandler
	instanceVariableNames: 'bot active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Core'!

!BotHandler commentStamp: 'FS 6/24/2008 21:18' prior: 0!
This class is an abstract class.  A subclass can define different behaviour for the bot. 
A bot has many BotHandler, each of them can be seen as functionalities for the bot.
!

BotHandler subclass: #AdminHandler
	instanceVariableNames: 'admins commands helpDictionary adminRegex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!AdminHandler commentStamp: 'FS 7/8/2008 14:40' prior: 0!
Administration handler for the bot. 
For a complete view of the available commands see #initializeCommandDictionary
Suppose the bots name is 'Anna' Commands:

- Anna, admin identify botPassword
- Anna, admin add-admin KenCausey
- Anna, admin join #squeak
- Anna admin create SayHiHandler
- Anna admin enable SayHiHandler
- Anna; admin disable SayHiHandler
- Anna, admin remove SayHiHandler

- Anna admin list admins
- Anna admin list channels
- Anna admin available handlers
- Anna admin all handlers
- Anna admin enable handlers

An admin _must_ be authentified on the network.
 !

!AdminHandler class methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 00:14'!
newForBot: bot
	| handler |
	handler := super newForBot: bot.
	handler addAdmin: 'fstephany'.
	handler initializeCommandDictionary.
	^handler.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 6/29/2008 15:26'!
addAdmin: nick 
	self admins add: nick! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 7/9/2008 16:49'!
adminRegex
	^ adminRegex! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 7/9/2008 16:49'!
adminRegex: anObject
	adminRegex := anObject! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 6/28/2008 00:02'!
admins
	^ admins! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 6/28/2008 00:02'!
admins: anObject
	admins := anObject! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 6/29/2008 11:40'!
commands
	^ commands! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 6/29/2008 11:40'!
commands: anObject
	commands := anObject! !

!AdminHandler methodsFor: 'admin for handlers' stamp: 'FS 7/17/2008 15:44'!
findHandlerAndProcessAdminFor: cmd msg: msg
	| handler |
	handler := self findHandlerFor: cmd.
	handler
		ifNil: [^false] 
		ifNotNil: [^handler adminCommand: cmd from: msg]
	! !

!AdminHandler methodsFor: 'admin for handlers' stamp: 'FS 7/17/2008 16:09'!
findHandlerFor: cmd
	"cmd has the form <handler> <token1> <token2>
	e.g., 'logging start logging #squeak' "
	| wantedHandler|
	wantedHandler := self extractFirstToken: cmd.
	^self bot activeHandlers  detect: [:h | h shortName = wantedHandler] ifNone: [^nil]! !

!AdminHandler methodsFor: 'help' stamp: 'FS 7/17/2008 16:16'!
generalHelp
	| help tab|
	tab := Character tab asString.
	help := OrderedCollection new
		add: 'Welcome in the administration of the squeakBot';
		add: 'You can use the following command:';
		yourself.
	self commands keysAndValuesDo: [ :key :value | 
			help add: ( '  ', key) asUppercase , tab , ' : ', value shortHelp].
	help 
		add: 'For more information about a particular command type:';
		add: ' /msg ', self bot nick, ' help admin COMMAND';
		add: 'You can also configure each handler individually. type:';
		add: '/msg ', self bot nick, ' help admin HANDLER';
		add: 'where HANDLER can be:'.
	self bot activeHandlers do: [:h | help add: ('  ' , h shortName) ].
	^help! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 21:56'!
generateAddAdmin
	^AdminCommand new
		methodSymbol: #processAddAdminCommand:matcher: ;
		regex: (self initRegex: 'add admin (.*)');
		shortHelp: 'adds an admin for the bot';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin ADD ADMIN nickname';
				add: 'Register the given nickname as an admin for the bot'; 
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:12'!
generateDisableHandler
	^AdminCommand new
		methodSymbol: #processDisableCommand:matcher: ;
		regex: (self initRegex: '^disable (.*)');
		shortHelp: 'disables an active handler';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin DISABLE handler';
				add: 'Disable the given handler. Notice that it does NOT delete it but make it inactive';
				add: 'the handler is still loaded but wont react to any message.';
				add: 'to see which handlers are currently active see the LIST ENABLE HANDLERS command';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateEnableHandler
	^AdminCommand new
		methodSymbol: #processEnableCommand:matcher: ;
		regex: (self initRegex: '^enable (.*)');
		shortHelp: 'enables an inactive handler';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin ENABLE handler';
				add: 'Enable the given handler. Notice that this command does not create a handler';
				add: 'it simple activate it if it had been deactived by a DISABLE command';
				add: 'to see which handlers are currently disabled see the LIST DISABLE HANDLERS command';
				yourself)! !

!AdminHandler methodsFor: 'help' stamp: 'FS 7/17/2008 16:06'!
generateHelpForCommand: command
	| handler |
	"admin command itself"
	self commands 
			at: command asLowercase
			ifPresent: [ :cmd | ^cmd longHelp].
	"admin command for a handler"
	handler := self findHandlerFor: (self extractFirstToken: command).
	handler ifNotNil: [^handler adminHelpFor: command].
	"nothing has matched"		
	^self generalHelp.! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateIdentify
	^AdminCommand new
		methodSymbol: #processIdentifyCommand:matcher: ;
		regex: (self initRegex: '^identify (.*)');
		shortHelp: 'identify the bot on the network';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin IDENTIFY password';
				add: 'Identify the bot against NickServ';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/16/2008 16:48'!
generateInvite
	^AdminCommand new
		methodSymbol: #processInviteCommand:matcher: ;
		regex: (self initRegex: '^invite (.*)');
		shortHelp: 'invites to a channel';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin INVITE channel';
				add: 'invites the bot to channel';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateJoin
	^AdminCommand new
		methodSymbol: #processJoinCommand:matcher: ;
		regex: (self initRegex: '^join (.*)');
		shortHelp: 'joins a channel';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin JOIN channelName';
				add: 'Tells the bot to join the given channel';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateLeave.
	^AdminCommand new
		methodSymbol: #processLeaveCommand:matcher: ;
		regex: (self initRegex: '^leave (.*)');
		shortHelp: 'leaves a channel';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin LEAVE channelName';
				add: 'Tells the bot to leave the given channel';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateListAdmins
	^AdminCommand new
		methodSymbol: #processListAdminsCommand:matcher: ;
		regex: (self initRegex: '^list admins');
		shortHelp: 'lists all admins of the bot';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin LIST ADMINS';
				add: 'Gives a list of all the bots administrators';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateListAllHandlers
	^AdminCommand new
		methodSymbol: #processListAllHandlersCommand:matcher: ;
		regex: (self initRegex: '^list all handlers');
		shortHelp: 'lists all the handler the bot has';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin LIST ALL HANDLERS';
				add: 'Lists all the handlers currently attached to the bot (active and inactive)';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateListChannels
	^AdminCommand new
		methodSymbol: #processListChannelsCommand:matcher: ;
		regex: (self initRegex: '^list channels');
		shortHelp: 'lists channels where the bot is present';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin LIST CHANNELS';
				add: 'Lists the channel on which the bot is connected';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateListDisabledHandlers
	^AdminCommand new
		methodSymbol: #processListDisabledHandlersCommand:matcher: ;
		regex: (self initRegex: '^list disabled handlers');
		shortHelp: 'lists inactive handlers';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin LIST DISABLED HANDLERS';
				add: 'Lists all the disabled handlers.';
				add: 'Those handlers are present but not active (i.e., ignore all messages)';
				add: 'They can be reactivated with the ENABLE command';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateListEnabledHandlers
	^AdminCommand new
		methodSymbol: #processListEnabledHandlersCommand:matcher: ;
		regex: (self initRegex: '^list enabled handlers');
		shortHelp: 'lists the active handlers';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin LIST ENABLED HANDLERS';
				add: 'Lists all the enabled handlers.';
				add: 'Those handlers can be deactivated with the DISABLE command';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateRemoveAdmin
	^AdminCommand new
		methodSymbol: #processRemoveAdminCommand:matcher:  ;
		regex: (self initRegex: '^remove admin (.*)');
		shortHelp: 'removes an admin';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin REMOVE ADMIN nickName';
				add: 'Removes the nickname from the admins list';
				yourself)! !

!AdminHandler methodsFor: 'help' stamp: 'FS 7/10/2008 22:38'!
help: token from: sender
	(self admins includes: sender)
		ifTrue: [ ^self generateHelpForCommand: token ]
		ifFalse: [ ^OrderedCollection new 
					add: 'You must be an admin to see the available commands';
					yourself].
! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:12'!
helpDictionary
	^ helpDictionary! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:12'!
helpDictionary: anObject
	helpDictionary := anObject! !

!AdminHandler methodsFor: 'initialize-release' stamp: 'FS 7/9/2008 21:37'!
initialize
	super initialize.
	self adminRegex: (self createRegexFor: ('^admin (.*)')) setCaseInsensitive.
	self admins: OrderedCollection new.! !

!AdminHandler methodsFor: 'initialize-release' stamp: 'FS 7/13/2008 00:05'!
initializeCommandDictionary
	self commands: (Dictionary newFrom:
		{ 
			'enable' -> self generateEnableHandler.
			'disable' -> self generateDisableHandler.
			'list all handlers' -> self generateListAllHandlers.
			'list enabled handlers' -> self generateListEnabledHandlers.
			'list disabled handlers' -> self generateListDisabledHandlers.
			'join' -> self generateJoin.
			'leave' -> self generateLeave.
			'list channels' -> self generateListChannels.
			'identify' -> self generateIdentify.
			'invite' -> self generateInvite.
			'list admins' -> self generateListAdmins.
			'add admin' -> self generateAddAdmin.
			'remove admin' -> self generateRemoveAdmin})! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/9/2008 21:35'!
processAddAdminCommand: msg matcher: aMatcher 
	| adminNick |
	adminNick := (aMatcher matchAt: 1) withBlanksTrimmed.
	self admins add: adminNick.
	self answerTo: msg with: adminNick , ' is now an admin'! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/16/2008 21:31'!
processDirectMessage: msg 
	"ignore non admin messages. Test if we have a valid command"
	| cmd |
	((self admins includes: msg sender) and: [self adminRegex matches: msg text]) 
		ifTrue: [ 
			cmd := adminRegex matchAt: 1.
			self commands valuesDo: [:command |
				(command regex matches: cmd) 
					ifTrue: [
						self perform: command methodSymbol with: msg with: command regex.
						^true ]].
			^self findHandlerAndProcessAdminFor: cmd msg: msg].
	^false
	! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/9/2008 15:56'!
processDisableCommand: msg matcher: aMatcher 
	| answer handlerName |
	handlerName := (aMatcher matchAt: 1) withBlanksTrimmed.
	answer := handlerName, ' has been disabled'.
	(handlerName = 'adminhandler')
		ifTrue: [answer := 'You cannot disable the admin']
		ifFalse: [
			[self bot disableHandler: handlerName]
				on: Error
				do: [:error | answer :=  handlerName, ' was not found']].
	self answerTo: msg with: answer.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/8/2008 14:58'!
processEnableCommand: msg matcher: aMatcher 
	| handlerName answer |
	handlerName := (aMatcher matchAt: 1) withBlanksTrimmed.
	answer := handlerName, ' has been activated'.
	[self bot enableHandler: handlerName]
		on: Error
		do: [:error | answer := handlerName , ' was not found.'].
	
	self answerTo: msg with: answer.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/9/2008 21:35'!
processIdentifyCommand: msg matcher: aMatcher 
	| password |
	password :=  (aMatcher matchAt: 1) withBlanksTrimmed .
	self bot identify: password.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/10/2008 15:42'!
processInviteCommand: msg matcher: aMatcher 
	| channelName |
	channelName :=  (aMatcher matchAt: 1) withBlanksTrimmed .
	self bot invite: channelName.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/1/2008 15:25'!
processJoinCommand: msg matcher: aMatcher 
	| channel |
	channel := (aMatcher matchAt: 1) withBlanksTrimmed.
	self bot joinChannel: channel..! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/1/2008 15:26'!
processLeaveCommand: msg matcher: aMatcher 
	| channel |
	channel := (aMatcher matchAt: 1) withBlanksTrimmed.
	self bot leaveChannel: channel.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/9/2008 21:52'!
processListAdminsCommand: msg matcher: aMatcher 
	"private answer to the sender -- not in the channel"
	self answerTo: msg with: admins asString.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/28/2008 12:29'!
processListAllHandlersCommand: msg matcher: aMatcher 
	"private answer to the sender -- not in the channel"
	| handlers |
	handlers := self bot handlers collect: [:each | ( '  ', each shortName) ].
	self answerMultiLinesMessageTo: msg with: handlers.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/9/2008 21:34'!
processListChannelsCommand: msg matcher: aMatcher 
	"private answer to the sender -- not in the channel"
	self answerTo: msg with: self bot channels asString.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/28/2008 12:27'!
processListDisabledHandlersCommand: msg matcher: aMatcher 
	"private answer to the sender -- not in the channel"
	| handlers |
	handlers := (self bot handlers select: [:handler | handler active not]) 
		collect: [:each | ( '  ', each shortName)].
	(handlers size = 0)
		ifTrue: [self answerTo: msg with: 'There''s no disabled handlers']
		ifFalse: [self answerMultiLinesMessageTo: msg with: handlers.]
	! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/28/2008 12:27'!
processListEnabledHandlersCommand: msg matcher: aMatcher 
	"private answer to the sender -- not in the channel"
	| handlers |
	handlers := (self bot handlers select: [:handler | handler active]) 
		collect: [:each | ( '  ', each shortName) ].
	self answerMultiLinesMessageTo: msg with: handlers.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/8/2008 15:04'!
processRemoveAdminCommand: msg matcher: aMatcher
	 | nick answer |
	nick := (aMatcher matchAt: 1) withBlanksTrimmed.
	answer := nick, ' is not an admin anymore'	.
	self admins remove: nick ifAbsent: [answer := nick, ' was not admin'].
	
	self answerTo: msg with: answer.! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:14'!
shortName
	^'admin'! !

!BotHandler class methodsFor: 'as yet unclassified' stamp: 'FS 6/28/2008 12:33'!
newForBot: aBot
	^self new bot: aBot.! !

!BotHandler methodsFor: 'accessing' stamp: 'FS 6/29/2008 08:41'!
active
	^ active ifNil: [ active := true ].! !

!BotHandler methodsFor: 'accessing' stamp: 'FS 6/28/2008 12:33'!
active: anObject
	active := anObject! !

!BotHandler methodsFor: 'administration' stamp: 'FS 7/16/2008 20:37'!
adminCommand: command
	"should be overriden by handlers which want to handle admin message"
	^false! !

!BotHandler methodsFor: 'help' stamp: 'FS 7/17/2008 15:59'!
adminHelpFor: command
	"should be overidden by subclasses"
	^OrderedCollection new add: 'Sorry... Theres no admin help available for this handler'; yourself! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 6/24/2008 14:30'!
amIQuotedIn: msg
	" am i quoted in the text message"
	| nick |
	nick := self bot nick.
	^(msg text findString: nick startingAt: 1 caseSensitive: false) > 0! !

!BotHandler methodsFor: 'answering' stamp: 'FS 7/9/2008 15:23'!
answerMultiLinesMessageTo: msg with: answer
	answer do: [:line |
		self answerTo: msg with: line ]! !

!BotHandler methodsFor: 'answering' stamp: 'FS 7/3/2008 16:46'!
answerMultiLinesPrivateMessageTo: msg with: answer
	answer do: [:line |
		self answerPrivateMessageTo: msg with: line ]! !

!BotHandler methodsFor: 'answering' stamp: 'FS 7/3/2008 16:15'!
answerPrivateMessageTo: msg with: answer
	"answer privately to the sender"
	self bot privMsgTo: msg sender text: answer! !

!BotHandler methodsFor: 'answering' stamp: 'FS 7/4/2008 21:28'!
answerTo: msg with: answer
	"answer to the msg. check if it is a direct or channel message"
	| recipient |
	(self bot isDirectMessage: msg)
		ifTrue: [ recipient := msg sender]
		ifFalse: [ recipient := msg recipient]. "channel msg"
	self bot privMsgTo: recipient text: answer.! !

!BotHandler methodsFor: 'accessing' stamp: 'FS 6/22/2008 21:33'!
bot
	^ bot! !

!BotHandler methodsFor: 'accessing' stamp: 'FS 6/22/2008 21:33'!
bot: anObject
	bot := anObject! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 7/1/2008 15:17'!
createRegexFor: aStringPattern
	"create a regex for a given pattern"
	^self regexClass forString: aStringPattern.! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 6/29/2008 08:40'!
disable
	self active: false.! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 6/29/2008 08:39'!
enable
	self active: true.! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 7/17/2008 16:01'!
extractFirstToken: aString
	[^((aString subStrings: ' ') at: 1) ] 
		on: Error do: [^'']! !

!BotHandler methodsFor: 'help' stamp: 'FS 7/17/2008 16:24'!
help: token from: sender
	"should be overidden by subclasses"
	^OrderedCollection new add: 'Sorry... Theres no help available for this handler'; yourself! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 7/16/2008 21:46'!
initRegex: aString
	^(self createRegexFor: aString) setCaseInsensitive.! !

!BotHandler methodsFor: 'process message' stamp: 'FS 7/17/2008 13:02'!
processChannelActivityMessage: msg
	^false! !

!BotHandler methodsFor: 'process message' stamp: 'FS 7/13/2008 00:00'!
processChannelMessage: msg
	^false! !

!BotHandler methodsFor: 'process message' stamp: 'FS 7/13/2008 00:02'!
processDirectMessage: msg
	^false! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 7/1/2008 15:14'!
regexClass
	"set the default regex class"
	^ ReRegex! !

!BotHandler methodsFor: 'accessing' stamp: 'FS 7/28/2008 12:47'!
shortName
	^self className! !

BotHandler subclass: #DicoHandler
	instanceVariableNames: 'definitions generalRequestPattern whatIsRequestPattern newDefinitionPattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!DicoHandler commentStamp: 'FS 7/7/2008 16:04' prior: 0!
This handler contains a dictionary filled with definitions.
Suppose bot's nick is Anna:

Anna, remember <object> is <definition>
Anna, what is <object>?

The prefix 'Anna' can be omitted if the request is directly sent by private message to the bot.!

!DicoHandler class methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 00:14'!
newForBot: bot
	| handler |
	handler := super newForBot: bot.
	handler initializePatterns.
	^handler.! !

!DicoHandler methodsFor: 'process message' stamp: 'FS 7/15/2008 16:53'!
answerDefinition: msg
	| object |
	(self whatIsRequestPattern matches: msg text) 
		ifTrue: [object := self whatIsRequestPattern matchAt: 1]
		ifFalse: [ (self generalRequestPattern matches: msg text) ifTrue: [
						object :=  self generalRequestPattern matchAt: 1]].
	object := object asLowercase withBlanksTrimmed.
	self answerDefinitionOf: object to: msg.! !

!DicoHandler methodsFor: 'process message' stamp: 'FS 7/15/2008 18:23'!
answerDefinitionOf: object to: msg
	| definition |
	definition := self definitions at: object ifAbsent: [nil].
	definition isNil
		ifTrue: [ self answerTo: msg with: ('Huh ?!!')]
		ifFalse: [ self answerTo: msg with: (object , ' is ', definition )].! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 6/23/2008 23:27'!
definitions
	^ definitions! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 6/23/2008 23:27'!
definitions: anObject
	definitions := anObject! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 7/15/2008 16:45'!
generalRequestPattern
	^ generalRequestPattern! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 7/15/2008 16:45'!
generalRequestPattern: anObject
	generalRequestPattern := anObject! !

!DicoHandler methodsFor: 'help' stamp: 'FS 7/15/2008 16:15'!
help: msg from: sender
	| help |
	help := OrderedCollection new.
	help 
		add: (self bot nick, ' can  remember useful definitions:');
		add: ('say: ', self bot nick, ' remember OBJECT is DEFINITION' );
		add: ('to add a definition and:');
		add: (self bot nick, ' what is OBJECT ?');
		add: ('or simply:');
		add: (self bot nick, ' OBJECT ?');
		add: ('to retrieve it').
		
	^help.! !

!DicoHandler methodsFor: 'initialize-release' stamp: 'FS 6/29/2008 15:58'!
initialize
	super initialize.
	self definitions: Dictionary new.! !

!DicoHandler methodsFor: 'initialize-release' stamp: 'FS 7/28/2008 12:03'!
initializePatterns
	| p1 p2 p3 |
	p1 := '^', self bot nick, '.* what is (.*?)\s*\??\s*$'.
	p2 := '^', self bot nick, '.* remember (.*?) is (.*)'.
	p3 := '^', self bot nick, '\s*[:;.,]?\s*(.*?)\s*\??\s*$'.
	self whatIsRequestPattern: (self createRegexFor: p1) setCaseInsensitive.
	self newDefinitionPattern:  (self createRegexFor: p2) setCaseInsensitive.
	self generalRequestPattern: (self createRegexFor: p3) setCaseInsensitive.! !

!DicoHandler methodsFor: 'testing' stamp: 'FS 7/16/2008 14:09'!
isDefinitionRequest: text
	^(self whatIsRequestPattern matches: text) 
			or: [self generalRequestPattern matches: text].! !

!DicoHandler methodsFor: 'testing' stamp: 'FS 7/15/2008 17:13'!
isNewDefinition: text
	^self newDefinitionPattern matches: text! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 6/24/2008 17:48'!
newDefinitionPattern
	^ newDefinitionPattern! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 6/24/2008 17:48'!
newDefinitionPattern: anObject
	newDefinitionPattern := anObject! !

!DicoHandler methodsFor: 'process message' stamp: 'FS 7/16/2008 14:08'!
processChannelMessage: msg
	(self isNewDefinition: msg text)
		ifTrue: [ self saveNewDefinition: msg. 
				^true].
	(self isDefinitionRequest: msg text)
		ifTrue: [ self answerDefinition: msg.
				^true].
	^false
	
	! !

!DicoHandler methodsFor: 'process message' stamp: 'FS 7/13/2008 00:41'!
processDirectMessage: msg
	"because the name of the bot is mpaybe not present if it is a directMessage"
	msg text: (self bot nick, ' ', msg text). "can change the message because its the last on the chain"
	^self processChannelMessage: msg.! !

!DicoHandler methodsFor: 'process message' stamp: 'FS 7/8/2008 15:26'!
saveNewDefinition: msg
	| object definition |	
	object := (self newDefinitionPattern matchAt: 1) asLowercase withBlanksTrimmed.
	definition := (self newDefinitionPattern matchAt: 2) withBlanksTrimmed.
	object ifNotNil: [ 
			self definitions at: object put: definition.
			self answerTo: msg with: ('definition of ', object, ' has been saved') ]! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:13'!
shortName
	^'dico'! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 7/15/2008 16:13'!
whatIsRequestPattern
	^ whatIsRequestPattern! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 7/15/2008 16:13'!
whatIsRequestPattern: anObject 
	whatIsRequestPattern := anObject! !

BotHandler subclass: #FakeHandler
	instanceVariableNames: 'messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!FakeHandler class methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 01:07'!
newForBot: bot
	| handler |
	handler := super newForBot: bot.
	^handler! !

!FakeHandler methodsFor: 'as yet unclassified' stamp: 'FS 6/29/2008 14:56'!
initialize
	super initialize.
	messages := OrderedCollection new.! !

!FakeHandler methodsFor: 'accessing' stamp: 'FS 6/29/2008 14:56'!
messages
	^ messages! !

!FakeHandler methodsFor: 'accessing' stamp: 'FS 6/29/2008 14:56'!
messages: anObject
	messages := anObject! !

!FakeHandler methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 01:15'!
processDirectMessage: msg
	messages add: msg.
	^true! !

BotHandler subclass: #HelpHandler
	instanceVariableNames: 'helpPattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!HelpHandler class methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 00:14'!
newForBot: bot
	| handler |
	handler := super newForBot: bot.
	handler initializeRegex.
	^handler! !

!HelpHandler methodsFor: 'initialize-release' stamp: 'FS 7/8/2008 20:33'!
help: token from: sender
	"the user has sent something like: '<botName> help' "
	| answer handlerName|
	answer := OrderedCollection new.
	answer
		add: 'Hi, im the SqueakBot : http://www.squeak.org/';
		add: 'For more information about a particular functionality, type:';
		add: '/msg ' , self bot nick , ' help HANDLER';
		add: 'where HANDLER can be:'.
	self bot activeHandlers do: [ :handler | 
		handlerName := handler className allButLast: 7.  " 'Handler' size = 7 "
		answer add: '   ' , handlerName ].
	^answer! !

!HelpHandler methodsFor: 'accessing' stamp: 'FS 7/8/2008 21:11'!
helpPattern
	^ helpPattern! !

!HelpHandler methodsFor: 'accessing' stamp: 'FS 7/8/2008 21:11'!
helpPattern: anObject
	helpPattern := anObject! !

!HelpHandler methodsFor: 'initialize-release' stamp: 'FS 7/9/2008 15:21'!
initializeRegex
	| pattern |
	pattern := '^', (self bot nick), '\s*[:;.,]?\s*help\s*([a-zA-z]*)\s*(.*)'.
	self helpPattern: (self createRegexFor: pattern) setCaseInsensitive.! !

!HelpHandler methodsFor: 'process message' stamp: 'FS 7/13/2008 00:03'!
processChannelMessage: msg 
	( self helpPattern matches: msg text)
		ifTrue: [ self processHelpWanted: msg.
				^true].
	^false! !

!HelpHandler methodsFor: 'process message' stamp: 'FS 7/13/2008 00:40'!
processDirectMessage: msg
	| copy | 
	copy := msg copy.
	copy text: (self bot nick, ': ', msg text ).
	^self processChannelMessage: copy.! !

!HelpHandler methodsFor: 'process message' stamp: 'FS 7/17/2008 16:50'!
processHelpWanted: msg
	| wantedHandler handler argument help|
	wantedHandler := (self helpPattern matchAt: 1) withBlanksTrimmed asLowercase.
	handler := self bot activeHandlers 
		detect: [:h | h shortName = wantedHandler]
		ifNone: [ self ].
	argument := self helpPattern matchAt: 2.
	help := handler help: argument from: msg sender.
	self answerMultiLinesMessageTo: msg with: help
	! !

!HelpHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:13'!
shortName
	^'help'! !

BotHandler subclass: #LoggingHandler
	instanceVariableNames: 'channelLoggers loggerClass adminCommands handlerRegex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!LoggingHandler commentStamp: 'FS 7/10/2008 17:33' prior: 0!
This handler logs all the traffic of the channels on which the bot is connected.
It does not log the private direct message to the bot.
See the defaultDirectory on instance side method to know where the log files are written!

!LoggingHandler class methodsFor: 'as yet unclassified' stamp: 'FS 7/16/2008 21:48'!
newForBot: bot
	| handler |
	handler := super newForBot: bot.
	handler initializeAdminCommandsDictionary.
	^handler! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/16/2008 21:30'!
adminCommand: command from: msg
	| cmd |
	(self handlerRegex matches: command) ifTrue: [
		cmd := self handlerRegex matchAt: 1.
		self adminCommands valuesDo: [:adminCmd |
			(adminCmd regex matches: cmd)
				ifTrue: [self perform: adminCmd methodSymbol with: msg with: adminCmd regex.
						^true]]].
	^false! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 16:43'!
adminCommands
	^ adminCommands! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 16:43'!
adminCommands: anObject
	adminCommands := anObject! !

!LoggingHandler methodsFor: 'help' stamp: 'FS 7/17/2008 16:42'!
adminHelpFor: command
	(self handlerRegex matches: command)
		ifTrue: [ self adminCommands 
				at: (self handlerRegex matchAt: 1)
				ifPresent: [ :cmd | ^cmd longHelp]].
	^self generalAdminHelp! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/12/2008 18:10'!
channelLoggers
	^ channelLoggers! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/12/2008 18:10'!
channelLoggers: anObject
	channelLoggers := anObject! !

!LoggingHandler methodsFor: 'utils' stamp: 'FS 7/16/2008 15:08'!
clearLogs
	self channelLoggers do: [:logger | logger clearLogs]! !

!LoggingHandler methodsFor: 'default values' stamp: 'FS 7/12/2008 18:09'!
defaultLoggerClass
	^FileChannelLogger! !

!LoggingHandler methodsFor: 'help' stamp: 'FS 7/17/2008 16:35'!
generalAdminHelp
	| help |
	help :=OrderedCollection new
		add: 'To configure the logging system type:';
		add: ' /msg Anna admin logging COMMAND';
		add: 'where COMMAND can be:';
		yourself.
	adminCommands keysAndValuesDo: [ :key :cmd |
		help add: ('   ', key, ' : ' , cmd shortHelp) ].
	help 
		add: ' ';
		 add: 'For more information about a particular command, type:';
		add: ' /msg Anna help admin logging COMMAND'.
	^help! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/17/2008 16:43'!
generateListLoggedChannels
	^AdminCommand new
		methodSymbol: #processListLoggedChannelCommand:matcher: ;
		regex: (self initRegex: '^list logged channels');
		shortHelp: 'List all the logged channels';
		longHelp: (OrderedCollection new
					add:' Syntax: /msg ', self bot nick, ' admin logging LIST LOGGED CHANNELS';
					add: 'Lists all the channels that are currently logged';
					yourself)! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/17/2008 16:43'!
generateStartLogging
	^AdminCommand new
		methodSymbol: #processStartLoggingCommand:matcher: ;
		regex: (self initRegex: '^start logging (.*)');
		shortHelp: 'Starts to log a channel';
		longHelp: (OrderedCollection new
					add:' Syntax: /msg ', self bot nick, ' admin logging START LOGGING channel';
					add: 'Starts to log the given channel';
					yourself)! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/17/2008 16:43'!
generateStopLogging
	^AdminCommand new
		methodSymbol: #processStopLoggingCommand:matcher: ;
		regex: (self initRegex: '^stop logging (.*)');
		shortHelp: 'Stops to log a channel';
		longHelp: (OrderedCollection new
					add:' Syntax: /msg ', self bot nick, ' admin logging STOP LOGGING channel';
					add: 'Stops to log the given channel';
					yourself)! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:42'!
handlerRegex
	^ handlerRegex! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:42'!
handlerRegex: anObject
	handlerRegex := anObject! !

!LoggingHandler methodsFor: 'initialize-release' stamp: 'FS 7/16/2008 21:48'!
initialize
	self loggerClass: self defaultLoggerClass.
	self channelLoggers: Dictionary new.
	self handlerRegex: (self createRegexFor: '^logging (.*)').! !

!LoggingHandler methodsFor: 'initialize-release' stamp: 'FS 7/16/2008 21:52'!
initializeAdminCommandsDictionary
	self adminCommands: (Dictionary newFrom:
		{
			'list logged channels' -> self generateListLoggedChannels.
			'start logging' -> self generateStartLogging.
			'stop logging' -> self generateStopLogging })! !

!LoggingHandler methodsFor: 'initialize-release' stamp: 'FS 7/16/2008 21:20'!
initializeLoggerForBot
	self bot channels do: [:chan | self logChannel: chan]! !

!LoggingHandler methodsFor: 'add - remove' stamp: 'FS 7/12/2008 19:23'!
logChannel: channel
	"creates a channelLogger for the given channel"
	self channelLoggers 
		at: channel 
		put: (self loggerClass newForChannel: channel)! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/12/2008 19:20'!
loggerClass
	^ loggerClass! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/12/2008 19:20'!
loggerClass: anObject
	loggerClass := anObject! !

!LoggingHandler methodsFor: 'process message' stamp: 'FS 7/17/2008 14:27'!
processChannelActivityMessage: msg
	self channelLoggers 
		at: msg channel
		ifPresent: [:log | log logChannelActivityMessage: msg].
		
	^false! !

!LoggingHandler methodsFor: 'process message' stamp: 'FS 7/13/2008 00:08'!
processChannelMessage: msg
	self channelLoggers 
		at: msg recipient 
		ifPresent: [:log | log logSimpleMessage: msg].
	
	"shouldnt stop the handlers chain"
	^false! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/16/2008 21:54'!
processListLoggedChannelCommand: msg matcher: matcher
	| answer |
	answer := OrderedCollection new.
	answer add: 'Channels that are currently logged: '.
	(self channelLoggers size = 0)
		ifTrue: [answer add: ' None'].
	self channelLoggers do: [:logger | answer add: ('  ', logger channel)].
	self answerMultiLinesMessageTo: msg with: answer.! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/16/2008 17:31'!
processStartLoggingCommand: msg matcher: matcher
	| channel |
	channel := matcher matchAt: 1.
	(channel size > 1) ifTrue: [
		self logChannel: channel.
		self answerTo: msg with: ('Start to log channel ', channel)]! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/16/2008 18:44'!
processStopLoggingCommand: msg matcher: matcher
	| channel answer |
	channel := matcher matchAt: 1.
	answer := 'Stop to log channel ', channel.
	[self stopLogChannel: channel]
		on: Error
		do: [ answer := channel].
	self answerTo: msg with: answer! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:12'!
shortName
	^'logging'! !

!LoggingHandler methodsFor: 'add - remove' stamp: 'FS 7/16/2008 18:34'!
stopLogChannel: channel
	"creates a channelLogger for the given channel"
	| logger |
	logger := self channelLoggers  at: channel.
	logger closeStream.
	self channelLoggers removeKey: channel.! !

BotHandler subclass: #SayHiHandler
	instanceVariableNames: 'replyMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!SayHiHandler commentStamp: 'FS 7/4/2008 22:12' prior: 0!
Simply answer when it receives a direct message or when it''s quoted in a channel
!

!SayHiHandler class methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 00:15'!
newForBot: bot
	| handler |
	handler := super newForBot: bot.
	^handler! !

!SayHiHandler methodsFor: 'handling' stamp: 'FS 6/23/2008 14:41'!
generateAnswer: msg
	^self replyMessages atRandom , ' ', msg sender.! !

!SayHiHandler methodsFor: 'accessing' stamp: 'FS 7/8/2008 20:30'!
help: msg from: sender
	^OrderedCollection new add: 'This handler say hello when I see my name somewhere'! !

!SayHiHandler methodsFor: 'initialize-release' stamp: 'FS 6/22/2008 21:38'!
initialize
	super initialize.
	self initializeReplyMessages.
	! !

!SayHiHandler methodsFor: 'initialize-release' stamp: 'FS 7/7/2008 18:35'!
initializeReplyMessages
	self replyMessages: OrderedCollection new.
	self replyMessages 
			add: 'Hi';
			add: 'Hello';
			add: 'Ola';
			add: 'Salut';
			add: 'Ciao';
			add: 'Dag'.
				! !

!SayHiHandler methodsFor: 'handling' stamp: 'FS 7/4/2008 21:09'!
processChannelMessage: msg
	self processMessage: msg isDirect: false! !

!SayHiHandler methodsFor: 'handling' stamp: 'FS 7/4/2008 21:08'!
processDirectMessage: msg
	self processMessage: msg isDirect: true.! !

!SayHiHandler methodsFor: 'handling' stamp: 'FS 7/4/2008 21:53'!
processMessage: msg isDirect: direct
	(direct or: [self amIQuotedIn: msg])
		ifTrue: [ self answerTo: msg with: (self generateAnswer: msg) ]! !

!SayHiHandler methodsFor: 'accessing' stamp: 'FS 6/22/2008 21:38'!
replyMessages
	^ replyMessages! !

!SayHiHandler methodsFor: 'accessing' stamp: 'FS 6/22/2008 21:38'!
replyMessages: anObject
	replyMessages := anObject! !

!SayHiHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:13'!
shortName
	^'sayhi'! !

Object subclass: #ChannelLogger
	instanceVariableNames: 'channel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!ChannelLogger class methodsFor: 'as yet unclassified' stamp: 'FS 7/12/2008 17:33'!
newForChannel: channelName
	^self new channel: channelName.! !

!ChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:32'!
channel
	^ channel! !

!ChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:32'!
channel: anObject
	channel := anObject! !

!ChannelLogger methodsFor: 'logging' stamp: 'FS 7/16/2008 15:08'!
clearLogs
	self subclassResponsibility! !

!ChannelLogger methodsFor: 'logging' stamp: 'FS 7/17/2008 13:54'!
logChannelActivityMessage: msg
	self subclassResponsibility! !

!ChannelLogger methodsFor: 'logging' stamp: 'FS 7/12/2008 17:32'!
logSimpleMessage: msg
	self subclassResponsibility! !

ChannelLogger subclass: #FakeChannelLogger
	instanceVariableNames: 'messagesLogged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!FakeChannelLogger methodsFor: 'initialize-release' stamp: 'FS 7/12/2008 21:15'!
initialize
	super initialize.
	self messagesLogged: OrderedCollection new.! !

!FakeChannelLogger methodsFor: 'stubs' stamp: 'FS 7/12/2008 21:10'!
logSimpleMessage: msg
	self messagesLogged add: msg.! !

!FakeChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 21:09'!
messagesLogged
	^ messagesLogged! !

!FakeChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 21:09'!
messagesLogged: anObject
	messagesLogged := anObject! !

ChannelLogger subclass: #FileChannelLogger
	instanceVariableNames: 'directory stream dateOfStream channelsActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!FileChannelLogger class methodsFor: 'as yet unclassified' stamp: 'FS 7/12/2008 21:50'!
newForChannel: channel
	| logger |
	logger := super newForChannel: channel.
	logger initializeStream.
	^logger! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/17/2008 14:16'!
channelsActivity
	^ channelsActivity! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/17/2008 14:16'!
channelsActivity: anObject
	channelsActivity := anObject! !

!FileChannelLogger methodsFor: 'stream utils' stamp: 'FS 7/12/2008 17:45'!
checkAndUpdateStream
	(self dateOfStream < Date today)
		ifTrue: [ self updateStream]! !

!FileChannelLogger methodsFor: 'stream utils' stamp: 'FS 7/16/2008 15:24'!
clearLogs
	self closeStream.
	self directory recursiveDelete.! !

!FileChannelLogger methodsFor: 'stream utils' stamp: 'FS 7/12/2008 22:20'!
closeStream
	self stream close.! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:35'!
dateOfStream
	^ dateOfStream! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:35'!
dateOfStream: anObject
	dateOfStream := anObject! !

!FileChannelLogger methodsFor: 'default values' stamp: 'FS 7/16/2008 15:23'!
defaultDirectory
	^FileDirectory default directoryNamed: 'IRC-logs'! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:35'!
directory
	^ directory! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:35'!
directory: anObject
	directory := anObject! !

!FileChannelLogger methodsFor: 'helper' stamp: 'FS 7/16/2008 15:23'!
directoryForDay: aDate
	" /!!\ does not assure that the directory exists !!"
	^((self directory
			directoryNamed: self channel)
			directoryNamed: aDate year asString)
			directoryNamed: aDate month name asString.! !

!FileChannelLogger methodsFor: 'helper' stamp: 'FS 7/17/2008 14:24'!
formatChannelActivityMessage: msg
	^(self channelsActivity at: msg command) value: msg
	! !

!FileChannelLogger methodsFor: 'helper' stamp: 'FS 7/17/2008 13:55'!
formatSimpleMessage: msg
	^msg sender , ' : ' , msg text.! !

!FileChannelLogger methodsFor: 'initialize-release' stamp: 'FS 7/17/2008 14:22'!
initialize
	self directory: self defaultDirectory.
	self initializeChannelActivityFormatter.! !

!FileChannelLogger methodsFor: 'initialize-release' stamp: 'FS 7/17/2008 14:26'!
initializeChannelActivityFormatter
	self channelsActivity: (Dictionary newFrom:
		{
			#join -> [:msg | msg user, ' has joined ' , msg channel ]. 
			#part -> [:msg | msg user, ' has left ' , msg channel , ' (' , msg text , ')'].
			#quit -> [:msg | msg user, ' has  quitted (' , msg text , ')']
		})! !

!FileChannelLogger methodsFor: 'initialize-release' stamp: 'FS 7/16/2008 16:13'!
initializeStream
	| today |
	today := Date today.
	self stream: 
		((self directoryForDay: today)
			assureExistence;
			fileNamed: today dayOfMonth asString).
	self stream setToEnd.
	self dateOfStream: today! !

!FileChannelLogger methodsFor: 'logging' stamp: 'FS 7/17/2008 13:54'!
logChannelActivityMessage: msg
	self checkAndUpdateStream.
	self stream 
		nextPut: Character cr;
		nextPutAll: (self formatChannelActivityMessage: msg).
		! !

!FileChannelLogger methodsFor: 'logging' stamp: 'FS 7/17/2008 13:54'!
logSimpleMessage: msg
	self checkAndUpdateStream.
	self stream 
		nextPut: Character cr;
		nextPutAll: (self formatSimpleMessage: msg).
		! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:35'!
stream
	^ stream! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:35'!
stream: anObject
	stream := anObject! !

!FileChannelLogger methodsFor: 'stream utils' stamp: 'FS 7/12/2008 17:46'!
updateStream
	self stream flush; close.
	self initializeStream.! !

Object subclass: #FakeBot
	instanceVariableNames: 'nick outgoingMessages directMessageSubscribers channelMessageSubscribers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!FakeBot commentStamp: 'FS 6/24/2008 14:31' prior: 0!
This bot simulates the behaviour of SocBot. It is used for testing handlers!

!FakeBot methodsFor: 'accessing' stamp: 'FS 7/7/2008 18:54'!
channelMessageSubscribers
	^ channelMessageSubscribers! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 7/7/2008 18:54'!
channelMessageSubscribers: anObject
	channelMessageSubscribers := anObject! !

!FakeBot methodsFor: 'stub methods' stamp: 'FS 7/12/2008 19:05'!
channels
	^OrderedCollection new 
		add: '#squeak';
		add: '#aida';
		yourself.! !

!FakeBot methodsFor: 'initialize-release' stamp: 'FS 7/7/2008 21:42'!
clearOutgoingMessages
	self outgoingMessages: OrderedCollection new.! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 7/4/2008 22:23'!
directMessageSubscribers
	^ directMessageSubscribers! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 7/4/2008 22:23'!
directMessageSubscribers: anObject
	directMessageSubscribers := anObject! !

!FakeBot methodsFor: 'initialize-release' stamp: 'FS 7/9/2008 15:18'!
initialize
	self clearOutgoingMessages.
	self directMessageSubscribers: OrderedCollection new.
	self channelMessageSubscribers: OrderedCollection new.
	self nick: 'Anna'.! !

!FakeBot methodsFor: 'stub methods' stamp: 'FS 7/4/2008 22:25'!
isDirectMessage: msg
	^msg recipient = self nick.! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 6/24/2008 14:29'!
nick
	^ nick! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 6/24/2008 14:29'!
nick: anObject
	nick := anObject! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 6/24/2008 20:24'!
outgoingMessages
	^ outgoingMessages! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 6/24/2008 20:24'!
outgoingMessages: anObject
	outgoingMessages := anObject! !

!FakeBot methodsFor: 'stub methods' stamp: 'FS 7/24/2008 18:08'!
privMsgTo: recipient text: aString 
	| message |
	message := IRCPrivateMessage 
		sender: self nick
		recipient: recipient
		text: aString.
	self outgoingMessages add: message! !

!FakeBot methodsFor: 'stub methods' stamp: 'FS 7/4/2008 22:22'!
subscribeToChannelMessages: aHandler
	self channelMessageSubscribers add: aHandler! !

!FakeBot methodsFor: 'stub methods' stamp: 'FS 7/4/2008 22:22'!
subscribeToDirectMessages: aHandler
	self directMessageSubscribers add: aHandler! !

Object subclass: #IRCAbstractMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCAbstractMessage class methodsFor: 'as yet unclassified' stamp: 'FS 7/27/2008 16:46'!
extractNickFromPrefix: aString
	"e.g., extracts fstephany from
	fstephany!!~fstephany@localhost"
	| stream |
	stream := ReadStream on: aString.
	^stream upTo: $!!! !

IRCAbstractMessage subclass: #IRCChannelActivityMessage
	instanceVariableNames: 'channel user command text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCChannelActivityMessage class methodsFor: 'instance creation' stamp: 'FS 7/17/2008 12:03'!
newForChannel: channel user: user command: command text: text
	^self new
		channel: channel;
		user: user;
		command: command;
		text: text! !

!IRCChannelActivityMessage class methodsFor: 'instance creation' stamp: 'FS 7/27/2008 16:46'!
newFromGenericMessage: msg
	| chanMsg |
	chanMsg := self new.
	chanMsg user: (self extractNickFromPrefix: msg sender).
	chanMsg command: msg command.
	(msg command = 'JOIN')
		ifTrue: [
			chanMsg channel: msg text.
			chanMsg text: '']
		ifFalse: [
			chanMsg channel: msg argument.
			chanMsg text: msg text].
	^chanMsg! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:00'!
channel
	^ channel! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:00'!
channel: anObject
	channel := anObject! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:02'!
command
	^ command! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:02'!
command: anObject
	command := anObject! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:00'!
text
	^ text! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:00'!
text: anObject
	text := anObject! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:00'!
user
	^ user! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:00'!
user: anObject
	user := anObject! !

IRCAbstractMessage subclass: #IRCPrivateMessage
	instanceVariableNames: 'sender recipient text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCPrivateMessage commentStamp: 'FS 7/24/2008 17:30' prior: 0!
Represents a simple private message!

!IRCPrivateMessage class methodsFor: 'as yet unclassified' stamp: 'FS 7/27/2008 16:25'!
newFromGenericMessage: genericMsg
	| privMsg |
	privMsg := self new.
	privMsg
		sender: (self extractNickFromPrefix: genericMsg sender);
		recipient: genericMsg argument;
		text: genericMsg text.
	^privMsg
	! !

!IRCPrivateMessage class methodsFor: 'as yet unclassified' stamp: 'FS 7/6/2008 17:13'!
sender: sender  recipient: recipient  text: text
	^self new
		sender: sender;
		recipient: recipient;
		text: text! !

!IRCPrivateMessage methodsFor: 'accessing' stamp: 'FS 7/6/2008 17:12'!
recipient
	^ recipient! !

!IRCPrivateMessage methodsFor: 'accessing' stamp: 'FS 7/6/2008 17:12'!
recipient: anObject
	recipient := anObject! !

!IRCPrivateMessage methodsFor: 'accessing' stamp: 'FS 7/6/2008 17:12'!
sender
	^ sender! !

!IRCPrivateMessage methodsFor: 'accessing' stamp: 'FS 7/6/2008 17:12'!
sender: anObject
	sender := anObject! !

!IRCPrivateMessage methodsFor: 'accessing' stamp: 'FS 7/6/2008 17:12'!
text
	^ text! !

!IRCPrivateMessage methodsFor: 'accessing' stamp: 'FS 7/6/2008 17:12'!
text: anObject
	text := anObject! !

IRCAbstractMessage subclass: #IRCServerMessage
	instanceVariableNames: 'command argument text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCServerMessage class methodsFor: 'as yet unclassified' stamp: 'FS 7/26/2008 15:09'!
newFromGenericMessage: genericMsg
	| msg |
	msg := self new.
	msg
		command: genericMsg command;
		argument: genericMsg argument;
		text: genericMsg text.
	^msg
	! !

!IRCServerMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 15:38'!
argument
	^ argument! !

!IRCServerMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 15:38'!
argument: anObject
	argument := anObject! !

!IRCServerMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 15:38'!
command
	^ command! !

!IRCServerMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 15:38'!
command: anObject
	command := anObject! !

!IRCServerMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 15:38'!
text
	^ text! !

!IRCServerMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 15:38'!
text: anObject
	text := anObject! !

Object subclass: #IRCClientAbstraction
	instanceVariableNames: 'profile privateMsgSubscriber channelActivityMsgSubscriber serverCommandSubscriber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCClientAbstraction commentStamp: 'FS 7/5/2008 20:01' prior: 0!
This class is the external interface of an IRC  client protocol.
It should satisfied any need for an IRC client (bot, graphical client, etc)!

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:46'!
channelActivityMsgSubscriber
	^ channelActivityMsgSubscriber! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:46'!
channelActivityMsgSubscriber: anObject
	channelActivityMsgSubscriber := anObject! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/25/2008 18:57'!
channels
	self subclassResponsibility.! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 18:08'!
connectTo: aServerName 
	self subclassResponsibility! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 17:51'!
disconnect
	self subclassResponsibility! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/24/2008 17:33'!
genericErrorString
	^'Must have subscribed before unsubscribe'! !

!IRCClientAbstraction methodsFor: 'initialize-release' stamp: 'FS 7/26/2008 17:27'!
initialize
	super initialize.
	self initializeSubscribers.
	self profile: IRCProfile new.
	! !

!IRCClientAbstraction methodsFor: 'initialize-release' stamp: 'FS 7/17/2008 12:48'!
initializeSubscribers
	self privateMsgSubscriber: OrderedCollection new.
	self serverCommandSubscriber: OrderedCollection new.
	self channelActivityMsgSubscriber: OrderedCollection new.! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 17:51'!
joinChannel: channelName
	self subclassResponsibility! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 17:51'!
leaveChannel: channelName
	self subclassResponsibility.! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 20:33'!
nick
	^ self profile nick! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 20:33'!
nick: aString
	^ self profile nick: aString! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/3/2008 19:13'!
privateMsgSubscriber
	^ privateMsgSubscriber! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/3/2008 19:13'!
privateMsgSubscriber: anObject
	privateMsgSubscriber := anObject! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 19:48'!
profile
	^ profile! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 19:48'!
profile: anObject
	profile := anObject! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 20:33'!
realName
	^ self profile realName! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 20:34'!
realName: aString
	^ self profile realName: aString! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 17:51'!
sendCommand: aString
	"send the string _as it is_ to the server"
	self subclassResponsibility! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 17:52'!
sendPrivateMsgTo: recipient text: text
	self subclassResponsibility! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/3/2008 19:13'!
serverCommandSubscriber
	^ serverCommandSubscriber! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/3/2008 19:13'!
serverCommandSubscriber: anObject
	serverCommandSubscriber := anObject! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/24/2008 17:42'!
subscribeToChannelActivityMsg: anObject
	"channel activity refers to the join / part / quit messages"
	self channelActivityMsgSubscriber add: anObject.! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/3/2008 19:16'!
subscribeToPrivateMsg: anObject
	" the subscriber will receive privmsg (i.e. direc and channels messages)"
	self privateMsgSubscriber add: anObject.! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/24/2008 17:31'!
subscribeToServerCommandMsg: anObject
	"Those messages are the numerical commands sent by the server"
	self serverCommandSubscriber add: anObject! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/24/2008 17:32'!
unsubscribeToChannelActivityMsg: anObject
	self channelActivityMsgSubscriber remove: anObject ifAbsent: [self error: self genericErrorString]! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/24/2008 17:33'!
unsubscribeToPrivateMsg: anObject
	self  privateMsgSubscriber remove: anObject ifAbsent: [self error: self genericErrorString]! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/24/2008 17:33'!
unsubscribeToServerCommandMsg: anObject
	"Those messages are the numerical commands sent by the server"
	self serverCommandSubscriber remove: anObject ifAbsent: [self error: self genericErrorString]! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 20:33'!
userName
	^ self profile userName! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 20:34'!
userName: aString
	^ self profile userName: aString! !

IRCClientAbstraction subclass: #IRCClientWrapper
	instanceVariableNames: 'connection commandHandler channels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCClientWrapper commentStamp: 'FS 7/24/2008 18:40' prior: 0!
wrap the IRCClientConnection class!

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:35'!
channels
	^channels! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 7/27/2008 16:33'!
channels: anObject
	channels := anObject! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 7/25/2008 18:50'!
commandHandler
	^ commandHandler! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 7/25/2008 18:50'!
commandHandler: anObject
	commandHandler := anObject! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 7/27/2008 16:41'!
connectTo: aServerName 
	(self connection isConnected) 
		ifTrue: [self error: 'already connected']
		ifFalse: [ self connection connectTo: aServerName andIndent: self profile].! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 7/27/2008 17:45'!
connection
	^connection ifNil: [connection := IRCClientConnection new wrapper: self].! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 7/27/2008 16:12'!
disconnect
	self connection close.! !

!IRCClientWrapper methodsFor: 'initialize-release' stamp: 'FS 7/27/2008 16:44'!
initialize
	super initialize.
	self channels: OrderedCollection new.
	self initializeCommandHandler.
	"lazy init for connection instance var."! !

!IRCClientWrapper methodsFor: 'initialize-release' stamp: 'FS 7/26/2008 14:35'!
initializeCommandHandler
	self commandHandler: (Dictionary newFrom:
		{
			'PRIVMSG' -> #processPrivMsg: .
			'NOTICE' -> #processNoticeMsg:.
			'NOTICE AUTH' -> #processNoticeMsg: .
			'JOIN' -> #processChannelActivityMsg: .
			'PART' -> #processChannelActivityMsg: .
			'QUIT' -> #processChannelActivityMsg: .
			"does take numeric commands into account"
		})! !

!IRCClientWrapper methodsFor: 'message processing' stamp: 'FS 7/27/2008 16:06'!
internalProcessChannelActivityMsg: chanMsg
	"to know that we've actually joined a channel'"
	((chanMsg user = self profile nick) and: [chanMsg command = 'JOIN'])
		ifTrue: [self channels add: chanMsg channel].
	! !

!IRCClientWrapper methodsFor: 'message processing' stamp: 'FS 7/27/2008 21:02'!
internalProcessServerMsg: servMsg
	"see RFC 2812 for a complete listing of the server commands ID"
	(servMsg command = '433')
		ifTrue: [ 
			self disconnect.
			self error: 'Nickname already in use']
	
	! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 7/27/2008 16:12'!
joinChannel: channelName 
	(self channels contains: channelName)
		ifFalse: [ self connection sendCommand: ('join ', channelName)]
	"channel is added to the channels list when we receive the confirmation from the server"! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 7/27/2008 16:12'!
leaveChannel: channelName 
	self connection sendCommand: ('part ', channelName).
	self channels remove: channelName ifAbsent: [].! !

!IRCClientWrapper methodsFor: 'message processing' stamp: 'FS 7/27/2008 16:47'!
processChannelActivityMsg: genericMsg
	| chanMsg |
	chanMsg := IRCChannelActivityMessage newFromGenericMessage: genericMsg.
	self internalProcessChannelActivityMsg: chanMsg.
	self channelActivityMsgSubscriber do: [ :each | each processChannelActivityMsg: chanMsg ]! !

!IRCClientWrapper methodsFor: 'message processing' stamp: 'FS 7/28/2008 16:15'!
processMessage: msg
	"process a IRCGenericMessage coming from the IRCClientConnection class"
	self commandHandler 
		at: msg command
		ifPresent: [:symbol | self perform: symbol with: msg. ^self].
	(msg command isAllDigits) ifTrue: [self processServerCommandMsg: msg].! !

!IRCClientWrapper methodsFor: 'message processing' stamp: 'FS 7/26/2008 14:59'!
processNoticeMsg: genericMsg
	"does nothing"! !

!IRCClientWrapper methodsFor: 'message processing' stamp: 'FS 7/27/2008 17:28'!
processPrivMsg: genericMsg
	| privMsg |
	privMsg := IRCPrivateMessage newFromGenericMessage: genericMsg.
	self privateMsgSubscriber do: [ :each | each processPrivateMsg: privMsg ]! !

!IRCClientWrapper methodsFor: 'message processing' stamp: 'FS 7/27/2008 21:09'!
processServerCommandMsg: genericMsg
	| msg |
	msg := IRCServerMessage newFromGenericMessage: genericMsg.
	self internalProcessServerMsg: msg.
	self serverCommandSubscriber do: [ :each | each processServerCommandMsg: msg ]! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 7/27/2008 16:13'!
sendCommand: aString 
	"send the string _as it is_ to the server"
	self connection sendCommand: aString! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 7/27/2008 16:16'!
sendPrivateMsgTo: recipient text: text 
	self connection sendCommand: ('privmsg ', recipient, ' :', text)! !

IRCClientAbstraction subclass: #IRCConnectionWrapper
	instanceVariableNames: 'connection commandsDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCConnectionWrapper commentStamp: 'FS 7/4/2008 17:33' prior: 0!
This class wrap the behaviour of IRCConnection to be easier to use.
The ultimate goal is to get rid of IRCConnection and define a new IRCClient engine.

Some methods can certainly be pushed up to the abstract superclass.!

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:06'!
channels
	self connection 
		ifNotNil: [
			^(self connection channelObservers) 
					inject: '' 
					into: [ :chanList :chanObs | chanList , ' ', chanObs channelName]] 
		ifNil: [''].! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/17/2008 11:37'!
commandsDictionary
	^ commandsDictionary! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/17/2008 11:37'!
commandsDictionary: anObject
	commandsDictionary := anObject! !

!IRCConnectionWrapper methodsFor: 'IRC network ' stamp: 'FS 7/4/2008 12:20'!
connectTo: serverName
	"See IRCConnection class for details"
	self connection 
		server: serverName;
		nick: self nick;
		fullName: self realName;
		userName: self userName;
		subscribeToProtocolMessages: self;
		openWindows;
		connect.! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:03'!
connection
	^ connection! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:03'!
connection: anObject
	connection := anObject! !

!IRCConnectionWrapper methodsFor: 'utilities' stamp: 'FS 7/17/2008 12:15'!
convertProtocolMsgToChannelActivityMsg: msg
	"IRCProtocolMessage to IRCChannelActivityMessage"
	| channelName user text  |
	(msg prefix isNil)
		ifFalse: [ user := self extractNickFromPrefix: msg prefix ].
	channelName := msg arguments at: 1.
	(msg arguments size = 2) 
		ifTrue: [text := msg arguments at: 2]
		ifFalse: [text := ''].
	^IRCChannelActivityMessage 
		newForChannel: channelName
		user: user
		command: msg command
		text: text! !

!IRCConnectionWrapper methodsFor: 'utilities' stamp: 'FS 7/24/2008 18:08'!
convertProtocolMsgToSimpleMsg: msg 
	"IRCProtocolMessage to IRCMessage"
	| sender recipient text |
	msg prefix isNil ifFalse: [ sender := self extractNickFromPrefix: msg prefix ].
	recipient := msg arguments at: 1.
	text := msg arguments at: 2.
	^ IRCPrivateMessage 
		sender: sender
		recipient: recipient
		text: text! !

!IRCConnectionWrapper methodsFor: 'IRC network ' stamp: 'FS 7/6/2008 15:29'!
disconnect
	self connection manualDisconnect.! !

!IRCConnectionWrapper methodsFor: 'utilities' stamp: 'FS 7/3/2008 19:03'!
extractNickFromPrefix: aString
	"e.g., extracts fstephany from
	fstephany!!~fstephany@localhost"
	| stream |
	stream := ReadStream on: aString.
	^stream upTo: $!!! !

!IRCConnectionWrapper methodsFor: 'initialize-release' stamp: 'FS 7/26/2008 17:27'!
initialize
	super initialize.
	self initializeCommandsDictionary.
	self connection: IRCConnection new.! !

!IRCConnectionWrapper methodsFor: 'initialize-release' stamp: 'FS 7/17/2008 12:18'!
initializeCommandsDictionary
	self commandsDictionary: (Dictionary newFrom:
		{ #privmsg -> #processPrivateMsg: .
			#join -> #processChannelActivityMsg: .
			#part -> #processChannelActivityMsg: .
			#quit -> #processChannelActivityMsg: })! !

!IRCConnectionWrapper methodsFor: 'message processing' stamp: 'FS 7/17/2008 12:19'!
ircProtocolMessage: msg
	"this is sent by IRCConnection to the protocolMessages subscribers
	msg is a IRCProtocolMessage"
	self commandsDictionary 
		at: msg command
		ifPresent: [:method | self perform: method with: msg].! !

!IRCConnectionWrapper methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 22:08'!
joinChannel: channelName
	self connection openChannelCaptured: channelName.! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/3/2008 19:43'!
leaveChannel: channelName
	self connection leave: channelName! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:01'!
nick
	^self profile nick! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/4/2008 11:54'!
nick: anObject
	self profile nick: anObject! !

!IRCConnectionWrapper methodsFor: 'message processing' stamp: 'FS 7/17/2008 12:58'!
processChannelActivityMsg: msg
	"see the commandsDictionary to know wich kind of messages are handled"
	| msgToForward |
	msgToForward := self convertProtocolMsgToChannelActivityMsg: msg.
	self channelActivityMsgSubscriber do: [ :each | each processChannelActivityMsg: msgToForward ]! !

!IRCConnectionWrapper methodsFor: 'message processing' stamp: 'FS 7/6/2008 16:46'!
processPrivateMsg: msg 
	"the msg is a privmsg"
	| msgToForward |
	msgToForward := self convertProtocolMsgToSimpleMsg: msg.
	self privateMsgSubscriber do: [ :each | each processPrivateMsg: msgToForward ]! !

!IRCConnectionWrapper methodsFor: 'message processing' stamp: 'FS 7/3/2008 19:20'!
processServerCommand: msg
	"process the command from the server. Command's number can be found in RFC 2812'"
	! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:33'!
realName
	^self profile realName! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/4/2008 11:57'!
realName: aString
	self profile realName: aString! !

!IRCConnectionWrapper methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 22:11'!
sendPrivateMsgTo: recipient text: text
	connection privmsgFrom: (self nick) to: recipient text: text! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/4/2008 12:00'!
userName
	^self profile userName! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/4/2008 12:00'!
userName: aString
	self profile userName: aString! !

Object subclass: #IRCClientConnection
	instanceVariableNames: 'socket bytesSent pendingPing floodLimit messagesToSend inBuffer wrapper msgRegex msgPingNoticeRegex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCClientConnection commentStamp: 'FS 7/25/2008 18:01' prior: 0!
Developed for the Squeak Bot.
Handles connection to a IRC server 
/!!\ not yet thread safe

msgRegex handles message strings like:
	:kikoolol.local NOTICE AUTH :*** Looking up your hostname...
	:kikoolol.local 001 tulipe :Welcome to the KikoololNetwork Internet Relay Chat Network tulipe
	:kikoolol.local 421 tulipe /msg :Unknown command
	:fstephany!!fstephany@i.love.debian.org PRIVMSG tulipe :Hello!!
	PING :kikoolol.local
	:kikoolol.local PONG kikoolol.local :blop 
	:fstephany!!fstephany@i.love.debian.org JOIN :#salonBleu
	:fstephany!!fstephany@i.love.debian.org PART #salonBleu :byebye!

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
bytesSent
	^ bytesSent! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
bytesSent: anObject
	bytesSent := anObject! !

!IRCClientConnection methodsFor: 'antiflood' stamp: 'FS 7/27/2008 22:13'!
checkFloodLimit
	" 'ping :blop' size + lf = 11 "
	(self pendingPing) ifTrue: [^false].
	(self bytesSent + 11 >= self floodLimit)
		ifTrue: [
			self sendPing. 
			self pendingPing: true.
			^false]
		ifFalse: [^true]
		! !

!IRCClientConnection methodsFor: 'connection' stamp: 'FS 7/27/2008 22:34'!
close
	((self socket isNil not) and: [self socket isConnected])
		ifTrue: [
			self socket sendData: ('quit', Character lf asString).
			[self socket sendDone] whileFalse: [].
			self socket close ].
	self socket: nil.
	self reset.
	! !

!IRCClientConnection methodsFor: 'connection' stamp: 'FS 7/26/2008 15:21'!
connectTo: server
	| addr |
	Socket initializeNetwork.
	self socket ifNotNil: [self socket destroy].
	addr := NetNameResolver addressForName: server.
	addr ifNil: [^ false].
	self socket: Socket new.
	self socket connectTo: addr port: 6667.
	^ true! !

!IRCClientConnection methodsFor: 'connection' stamp: 'FS 7/27/2008 16:40'!
connectTo: server andIndent: profile
	(self connectTo: server) ifFalse: [self error: 'cant connect'].
	self startLoop.
	self indentWithProfile: profile! !

!IRCClientConnection methodsFor: 'network IO' stamp: 'FS 7/27/2008 21:51'!
emptyMessagesToSend
	| bytes msg |
	[ self socket sendDone 
		and: [self messagesToSend notEmpty]
		and: [self checkFloodLimit]]
		whileTrue: [
			msg := (self messagesToSend removeFirst) , ((Character lf) asString).
			bytes := self socket sendData: msg.
			self incrementBytesSent: bytes ]! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
floodLimit
	^ floodLimit! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
floodLimit: anObject
	floodLimit := anObject! !

!IRCClientConnection methodsFor: 'message processing' stamp: 'FS 7/28/2008 16:53'!
generateGenericMessageFrom: msgString.
	(self msgRegex matches: msgString)
		ifTrue: [ 
			^IRCGenericMessage new
				sender: (self msgRegex matchAt: 1);
				command: (self msgRegex matchAt: 2);
				argument: (self msgRegex matchAt: 3);
				text: (self msgRegex matchAt: 4)].
	(self msgPingNoticeRegex matches: msgString)
		ifTrue: [
			^IRCGenericMessage new
				command: (self msgPingNoticeRegex matchAt: 1);
				text: (self msgPingNoticeRegex matchAt: 2)].
	^nil! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
inBuffer
	^ inBuffer! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
inBuffer: anObject
	inBuffer := anObject! !

!IRCClientConnection methodsFor: 'antiflood' stamp: 'FS 7/27/2008 21:12'!
incrementBytesSent: increment
	self bytesSent: (self bytesSent + increment)! !

!IRCClientConnection methodsFor: 'connection' stamp: 'FS 7/26/2008 15:27'!
indentWithProfile: profile
	self sendCommand: ('nick ', profile nick).
	self sendCommand: ('user ', profile userName , ' * * :', profile realName).! !

!IRCClientConnection methodsFor: 'initialize-release' stamp: 'FS 7/27/2008 21:56'!
initialize
	self floodLimit: 1500.
	self pendingPing: false.
	self reset.
	self initializeMsgRegex.! !

!IRCClientConnection methodsFor: 'initialize-release' stamp: 'FS 7/28/2008 16:42'!
initializeMsgRegex
	self msgRegex: (ReRegex  newForPattern: 
		':(.+?)\s(PRIVMSG|PONG|JOIN|PART|QUIT|NOTICE AUTH|NOTICE|\d{3})\s?(.*?) :(.*)').
	self msgPingNoticeRegex: (ReRegex newForPattern:
		'^(PING|NOTICE AUTH|NOTICE) :(.*)').! !

!IRCClientConnection methodsFor: 'testing' stamp: 'FS 7/21/2008 17:23'!
isConnected
	^(socket isNil not) 
		and: [socket isValid]
		and: [socket isConnected]! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
messagesToSend
	^ messagesToSend! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
messagesToSend: anObject
	messagesToSend := anObject! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/28/2008 16:38'!
msgPingNoticeRegex
	^ msgPingNoticeRegex! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/28/2008 16:38'!
msgPingNoticeRegex: anObject
	msgPingNoticeRegex := anObject! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/25/2008 18:00'!
msgRegex
	^ msgRegex! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/25/2008 18:00'!
msgRegex: anObject
	msgRegex := anObject! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/27/2008 21:56'!
pendingPing
	^ pendingPing! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/27/2008 21:56'!
pendingPing: anObject
	pendingPing := anObject! !

!IRCClientConnection methodsFor: 'network IO' stamp: 'FS 7/21/2008 18:09'!
processIO
	"dont use it manually !! See startLoop"
	(self isConnected) ifFalse: [self error: 'Must be connected'].
	self emptyMessagesToSend.
	self receiveMessages.
	^true.! !

!IRCClientConnection methodsFor: 'message processing' stamp: 'FS 7/27/2008 22:12'!
processPingPongMessage: aMsg
	(aMsg command = 'PING')
		ifTrue: [self replyToPing: aMsg]
		ifFalse: [self processPong: aMsg]! !

!IRCClientConnection methodsFor: 'message processing' stamp: 'FS 7/27/2008 22:12'!
processPong: aMsg
	"reset the counter."
	self bytesSent: 0.
	self pendingPing: false.! !

!IRCClientConnection methodsFor: 'message processing' stamp: 'FS 7/27/2008 22:12'!
processRawMessage: msgString
	"only forward interesting messages to the wrapper"
	| msg |
	msg := self generateGenericMessageFrom: msgString.
	msg ifNil: [^self].
	((msg command = 'PING') or: [msg command = 'PONG'])
		ifTrue: [self processPingPongMessage: msg]
		ifFalse: [self wrapper processMessage: msg].
	Transcript cr; show: msgString.! !

!IRCClientConnection methodsFor: 'network IO' stamp: 'FS 7/24/2008 17:18'!
receiveMessages
	| idx msgText |
	[ socket dataAvailable]
		whileTrue: [ self inBuffer: (self inBuffer , socket receiveData) ].	
	[idx := self inBuffer indexOf: Character lf. idx > 0]
		whileTrue: [
			msgText  := self inBuffer copyFrom: 1 to: idx.
			self processRawMessage: msgText.
			self inBuffer: (self inBuffer copyFrom: (idx +1) to: self inBuffer size)]
	! !

!IRCClientConnection methodsFor: 'message processing' stamp: 'FS 7/27/2008 17:34'!
replyToPing: aMsg
	self sendCommand: ('pong :', aMsg text)! !

!IRCClientConnection methodsFor: 'initialize-release' stamp: 'FS 7/26/2008 15:42'!
reset
	self bytesSent: 0.
	self messagesToSend: OrderedCollection new.
	self inBuffer: ''.! !

!IRCClientConnection methodsFor: 'connection' stamp: 'FS 7/24/2008 16:56'!
sendCommand: aStringCommand
	"the command will be sent _as it is_ to the server"
	self messagesToSend addLast: aStringCommand.! !

!IRCClientConnection methodsFor: 'antiflood' stamp: 'FS 7/27/2008 22:22'!
sendPing
	| bytes |
	bytes :=self socket sendData: ('ping :blop', (Character lf asString)).! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
socket
	^ socket! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
socket: anObject
	socket := anObject! !

!IRCClientConnection methodsFor: 'network IO' stamp: 'FS 7/27/2008 17:51'!
startLoop.
	[ 
		[self isConnected and: [self processIO]]
			whileTrue: [(Delay forMilliseconds: 10) wait]. 
	] fork.
	! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/24/2008 18:38'!
wrapper
	^ wrapper! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/24/2008 18:38'!
wrapper: anObject
	wrapper := anObject! !

Object subclass: #IRCClientProfile
	instanceVariableNames: 'nick realName userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Core'!

!IRCClientProfile class methodsFor: 'as yet unclassified' stamp: 'FS 7/3/2008 18:17'!
newWithNick: aNick userName: user realName: real
	^self new
		nick: aNick;
		userName: user;
		realName: real.! !

!IRCClientProfile methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:14'!
nick
	^ nick! !

!IRCClientProfile methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:14'!
nick: anObject
	nick := anObject! !

!IRCClientProfile methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:14'!
realName
	^ realName! !

!IRCClientProfile methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:14'!
realName: anObject
	realName := anObject! !

!IRCClientProfile methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:14'!
userName
	^ userName! !

!IRCClientProfile methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:14'!
userName: anObject
	userName := anObject! !

Object subclass: #IRCGenericMessage
	instanceVariableNames: 'sender command argument text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCGenericMessage commentStamp: 'FS 7/27/2008 16:18' prior: 0!
This is a basic representation of a IRC message. 
It _shouldnt_ be used outside the IRCClientConnection class.!

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
argument
	^ argument! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
argument: anObject
	argument := anObject! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
command
	^ command! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
command: anObject
	command := anObject! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
sender
	^ sender! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
sender: anObject
	sender := anObject! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
text
	^ text! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
text: anObject
	text := anObject! !

Object subclass: #IRCProfile
	instanceVariableNames: 'nick userName realName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCProfile methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:26'!
nick
	^ nick! !

!IRCProfile methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:26'!
nick: anObject
	nick := anObject! !

!IRCProfile methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:26'!
realName
	^ realName! !

!IRCProfile methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:26'!
realName: anObject
	realName := anObject! !

!IRCProfile methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:26'!
userName
	^ userName! !

!IRCProfile methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:26'!
userName: anObject
	userName := anObject! !

Object subclass: #LogReader
	instanceVariableNames: 'day'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Website'!

Object subclass: #LogReaderApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Website'!

!LogReaderApp methodsFor: 'views' stamp: 'FS 7/18/2008 18:01'!
viewMain
	| e |
	e := WebElement new.
	e addTextH1: 'Log Reader'.
	self pageFrameWith: e title: 'Log Reader'.! !

Object subclass: #SocBot
	instanceVariableNames: 'server handlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Core'!

!SocBot commentStamp: 'FS 7/4/2008 22:16' prior: 0!
A SocBot can connect to an IRC network in an automated way..

Instance Variables
	server:			is the connection to a server (must be a subclass of IRCClientAbstraction)
	directMessageSubscribers  are the handlers which want to get notified when the bot gets direct messages
	channelMessageSubscribers idem but for channel messages

Entry point of messages: #processPrivateMsg:
Example:
bot := SocBot newWithNick: 'Anna'.
bot connectTo: 'localhost'.
bot joinChannel: '#salonBleu'.
bot createHandler: 'SayHiHandler'.
bot createHandler: 'DicoHandler'.
bot identify: 'blopouille'.
bot disconnect.!

!SocBot class methodsFor: 'default values' stamp: 'FS 7/4/2008 12:04'!
defaultRealName
	^self defaultUserName ! !

!SocBot class methodsFor: 'default values' stamp: 'FS 7/4/2008 12:01'!
defaultUserName
	^'Squeak Bot'! !

!SocBot class methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 00:25'!
newWithNick: aNick
	^self new 
		nick: aNick;
		userName: self defaultUserName;
		realName: self defaultRealName;
		initializeDefaultHandlers.
! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/4/2008 23:03'!
activeHandlers
	^self handlers select: [:h | h active]! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:06'!
channels
	"channels in which the bot is connected"
	^self server channels! !

!SocBot methodsFor: 'network' stamp: 'FS 7/3/2008 22:00'!
connectTo: serverName 
	self server connectTo: serverName! !

!SocBot methodsFor: 'default values' stamp: 'FS 7/26/2008 15:10'!
defaultClientAbstractionClass
	^IRCClientWrapper! !

!SocBot methodsFor: 'default values' stamp: 'FS 7/16/2008 15:02'!
defaultHandlers
	^OrderedCollection new
		add: (LoggingHandler newForBot: self);
		add: (HelpHandler newForBot: self);
		add: (AdminHandler newForBot: self);
		add: (DicoHandler newForBot: self);
		yourself! !

!SocBot methodsFor: 'handlers' stamp: 'FS 6/29/2008 12:00'!
disableHandler: aHandlerNameString
	| handler |
	handler := self findHandler: aHandlerNameString.
	handler ifNotNil: [ handler disable].! !

!SocBot methodsFor: 'network' stamp: 'FS 7/3/2008 22:07'!
disconnect
	self server disconnect.! !

!SocBot methodsFor: 'handlers' stamp: 'FS 6/29/2008 11:59'!
enableHandler: aHandlerNameString
	| handler |
	handler := self findHandler: aHandlerNameString.
	handler ifNotNil: [ handler enable].! !

!SocBot methodsFor: 'handlers' stamp: 'FS 7/28/2008 12:35'!
findHandler: aHandlerNameString
	" for dicoHandler recognise: 
		- dicoHandler
		- dico"
	aHandlerNameString translateToLowercase.
	^self handlers  detect: [:each | 
			(each shortName = aHandlerNameString)
				or: [each className asLowercase = aHandlerNameString]]

		
! !

!SocBot methodsFor: 'message handling' stamp: 'FS 7/17/2008 13:00'!
forwardMessage: msg selector: selector
	"stop the chain when a handler answers true"
	self handlers detect: [:handler | (handler active) 
							and: [ handler perform: selector with: msg]]
				ifNone: []! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/12/2008 23:51'!
handlers
	^handlers! !

!SocBot methodsFor: 'accessing' stamp: 'FS 6/15/2008 21:22'!
handlers: anObject
	handlers := anObject! !

!SocBot methodsFor: 'network' stamp: 'FS 6/23/2008 21:20'!
identify: password
	self privMsgTo: 'nickserv' text: ('identify ', password )! !

!SocBot methodsFor: 'initialize-release' stamp: 'FS 7/26/2008 15:11'!
initialize
	super initialize.
	self handlers: OrderedCollection new.
	self server: (self defaultClientAbstractionClass ) new.
	self server subscribeToPrivateMsg: self.
	self server subscribeToChannelActivityMsg: self.! !

!SocBot methodsFor: 'initialize-release' stamp: 'FS 7/13/2008 00:25'!
initializeDefaultHandlers
	self handlers: self defaultHandlers! !

!SocBot methodsFor: 'network' stamp: 'FS 7/10/2008 15:40'!
invite: channelName
	self privMsgTo: 'chanserv' text: ('invite ', channelName )! !

!SocBot methodsFor: 'testing' stamp: 'FS 7/3/2008 21:59'!
isConnected
	self shouldBeImplemented! !

!SocBot methodsFor: 'testing' stamp: 'FS 7/4/2008 18:25'!
isDirectMessage: msg
	^msg recipient = self nick.! !

!SocBot methodsFor: 'testing' stamp: 'FS 7/12/2008 23:54'!
isFromMe: msg
	"test whether or not a message comes from me..."
	^msg sender isNil or: [msg sender = self nick]! !

!SocBot methodsFor: 'network' stamp: 'FS 7/4/2008 12:21'!
joinChannel: aString
	self server joinChannel: aString! !

!SocBot methodsFor: 'network' stamp: 'FS 7/4/2008 21:03'!
leaveChannel: channelToLeave
	self server leaveChannel: channelToLeave.! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:03'!
nick
	^self server nick! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:03'!
nick: aString
	self server nick: aString! !

!SocBot methodsFor: 'network' stamp: 'FS 7/4/2008 18:02'!
privMsgTo: recipient text: aString
	"send a privmsg to the recipient (which can be an individual or a channel)"
	self server sendPrivateMsgTo: recipient text: aString! !

!SocBot methodsFor: 'message handling' stamp: 'FS 7/17/2008 14:03'!
processChannelActivityMsg: msg
	self forwardMessage: msg selector: #processChannelActivityMessage:.! !

!SocBot methodsFor: 'message handling' stamp: 'FS 7/28/2008 16:11'!
processPrivateMsg: msg
	"send by the server. A private message can be for channel or direct"
	| selector |
	(self isFromMe: msg) ifTrue: [^self].
	(self isDirectMessage: msg)
		ifTrue: [ selector := #processDirectMessage: ]
		ifFalse: [ selector := #processChannelMessage: ].
	self forwardMessage: msg selector: selector.! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:38'!
realName
	^ self server realName! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/4/2008 12:04'!
realName: aString
	self server realName: aString! !

!SocBot methodsFor: 'accessing' stamp: 'FS 6/15/2008 21:22'!
server
	^ server! !

!SocBot methodsFor: 'accessing' stamp: 'FS 6/15/2008 21:22'!
server: anObject
	server := anObject! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/4/2008 12:02'!
userName
	^ self server userName! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/4/2008 12:04'!
userName: aString
	self server userName: aString! !

TestCase subclass: #AdminHandlerTest
	instanceVariableNames: 'bot adminHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!AdminHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 6/29/2008 15:53'!
setUp
	bot := FakeBot new.
	bot nick: 'Anna'.
	adminHandler := AdminHandler newForBot: bot.! !

!AdminHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 6/30/2008 19:07'!
testAddAdmin
	| initialSize |
	initialSize := adminHandler admins size.
	
	adminHandler addAdmin: 'Ken'.
	self assert: (adminHandler admins size = ( initialSize + 1)).
	self assert: (adminHandler admins includes: 'Ken') "Ken is a valid key"! !

!AdminHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/9/2008 22:14'!
testIsDisableCommand
	"see AdminHandler class definition or valid msgs"
	| reRegex |
	reRegex := (adminHandler commands at: 'disable') regex.
	self 
		assert: (reRegex matches: 'disable SayHiHandler');
		assert: (reRegex matches: 'DISABLE sayhihandler');
		deny: (reRegex matches: 'admin disable SayHiHandler');
		deny: (reRegex matches: ' disable Blopblop ').! !

!AdminHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/9/2008 22:15'!
testIsEnableCommand
	"see AdminHandler class definition or valid msgs"
	| reRegex |
	reRegex := (adminHandler commands at: 'enable') regex.
	self 
		assert: (reRegex matches: 'enable SayHiHandler');
		assert: (reRegex matches: 'ENABLE  SayHiHandler');
		deny: (reRegex matches: 'admin word enable SayHiHandler').
! !

!AdminHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/9/2008 22:16'!
testIsIdentifyCommand
	"see AdminHandler class definition or valid msgs"
	| reRegex |
	reRegex := (adminHandler commands at: 'identify') regex.
	self 
		assert: (reRegex matches: 'identify password');
		deny: (reRegex matches: 'admin identify').
	! !

!AdminHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/9/2008 22:16'!
testIsJoinCommand
	"see AdminHandler class definition or valid msgs"
	| reRegex |
	reRegex := (adminHandler commands at: 'join') regex.
	self 
		assert: (reRegex matches: 'join #squeak');
		deny: (reRegex matches: 'joins #squeak').! !

!AdminHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/9/2008 22:17'!
testIsNewAdminCommand
	"see AdminHandler class definition or valid msgs"
	| reRegex |
	reRegex := (adminHandler commands at: 'add admin') regex.
	self
		assert: (reRegex matches: 'add admin Ken');
		deny: (reRegex matches: 'add adminKen')! !

!AdminHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 6/29/2008 16:42'!
testProcessMessage
	! !

TestCase subclass: #DicoHandlerTest
	instanceVariableNames: 'bot dicoHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!DicoHandlerTest methodsFor: 'utilities' stamp: 'FS 7/24/2008 18:08'!
fillHandlerWithDefinition
	| msg1 msg2 msg3 |
	msg1 := IRCPrivateMessage 
		sender: 'test'
		recipient: 'Anna'
		text: 'Anna; remember squeak is a smalltalk implementation'.
	msg2 := IRCPrivateMessage 
		sender: 'test'
		recipient: 'Anna'
		text: 'Anna; remember belgium is a tiny country'.
	msg3 := IRCPrivateMessage 
		sender: 'test'
		recipient: 'Anna'
		text: 'Anna; remember tea is the best drink ever'.
	dicoHandler
		processDirectMessage: msg1;
		processDirectMessage: msg2;
		processDirectMessage: msg3! !

!DicoHandlerTest methodsFor: 'utilities' stamp: 'FS 7/15/2008 16:59'!
isGeneralDefinitionRequest: text
	^dicoHandler generalRequestPattern matches: text
		
		
	! !

!DicoHandlerTest methodsFor: 'utilities' stamp: 'FS 7/15/2008 16:56'!
isWhatIsDefinitionRequest: text
	^dicoHandler whatIsRequestPattern matches: text
		
		
	! !

!DicoHandlerTest methodsFor: 'testing' stamp: 'FS 6/24/2008 14:42'!
setUp
	bot := FakeBot new.
	bot nick: 'Anna'.
	dicoHandler := DicoHandler newForBot: bot.! !

!DicoHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/24/2008 18:08'!
testAnswerDefinition
	| msg1 msg2 msg3 msgCount |
	self fillHandlerWithDefinition.
	msgCount := bot outgoingMessages size.
	"simulates new messages"
	msg1 := IRCPrivateMessage 
		sender: 'unittest'
		recipient: 'Anna'
		text: 'what is squeak?'.
	msg2 := IRCPrivateMessage 
		sender: 'unittest'
		recipient: '#squeak'
		text: 'Anna, what is belgium ?'.
	msg3 := IRCPrivateMessage 
		sender: 'unittest'
		recipient: '#squeak'
		text: 'Anna, what is key that doesnt exist ?'.
	dicoHandler processDirectMessage: msg1.
	dicoHandler processChannelMessage: msg2.
	dicoHandler processChannelMessage: msg3.
	self assert: bot outgoingMessages size = (msgCount + 3)! !

!DicoHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/16/2008 14:23'!
testGeneralRequest
	| matcher |
	matcher := dicoHandler generalRequestPattern.
	{ 'Anna, squeak?'.
		'Anna: squeak ?'.
		'Anna, squeak'.
		'Anna: squeak? '.
		'Anna squeak ' } 
	do: [:each |
			matcher matches: each.
			 self assert: ((matcher matchAt: 1) = 'squeak')].! !

!DicoHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/15/2008 17:01'!
testIsGeneralDefinitionRequest
	self 
		assert: (self  isGeneralDefinitionRequest: 'Anna, Monticello ?');
		assert: (self  isGeneralDefinitionRequest: 'Anna, monticello');
		assert: (self  isGeneralDefinitionRequest: 'Anna    ; Smalltalk?');
		assert: (self  isGeneralDefinitionRequest: 'Anna the bot Smalltalk?');
		deny: (self  isGeneralDefinitionRequest: 'plane?');
		deny: (self  isGeneralDefinitionRequest: 'what is smalltalk Anna ?').
		
		
		
	! !

!DicoHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/8/2008 14:32'!
testIsNewDefinition
	self
		assert: (dicoHandler isNewDefinition: 'Anna REMEMBER wikipedia is an encyclopedia');
		assert: (dicoHandler isNewDefinition: 'Anna: please remember smalltalk is a great environment');
		assert: (dicoHandler isNewDefinition: 'Anna, remember this is not that ');
		deny: (dicoHandler isNewDefinition: 'Anna i tell you java is great' );
		deny: (dicoHandler isNewDefinition: ' Anna, remember squeak is a smalltalk').! !

!DicoHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/15/2008 16:59'!
testIsWhatIsDefinitionRequest
	self 
		assert: (self  isWhatIsDefinitionRequest: 'Anna, WHAT is Monticello ?');
		assert: (self  isWhatIsDefinitionRequest: 'Anna: what is a plane?');
		assert: (self  isWhatIsDefinitionRequest: 'Anna what is Smalltalk?');
		assert: (self  isWhatIsDefinitionRequest: 'Anna the bot what is Smalltalk?');
		deny: (self  isWhatIsDefinitionRequest: 'what is a plane  ?');
		deny: (self  isWhatIsDefinitionRequest: 'what is smalltalk Anna ?').
		
		
		
	! !

!DicoHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/24/2008 18:08'!
testSaveNewDefinition
	| msg1 msg2 |
	msg1 := IRCPrivateMessage 
		sender: 'unittest'
		recipient: '#squeak'
		text: 'Anna, remember squeak is a smalltalk implementation'.
	msg2 := IRCPrivateMessage 
		sender: 'unittest'
		recipient: 'Anna'
		text: 'please remember JAVA is a programming language'.
	dicoHandler
		processChannelMessage: msg1;
		processDirectMessage: msg2.
	self
		assert: dicoHandler definitions size = 2;
		assert: (dicoHandler definitions at: 'squeak') = 'a smalltalk implementation';
		assert: (dicoHandler definitions at: 'java') = 'a programming language'! !

!DicoHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/16/2008 10:12'!
testWhatIsRequest
	| matcher |
	matcher := dicoHandler whatIsRequestPattern.
	{ 'Anna, what is squeak?'.
		'Anna, what is squeak ?'.
		'Anna, what is squeak'.
		'Anna, what is squeak? '.
		'Anna, what is squeak ' } 
	do: [:each |
			matcher matches: each.
			 self assert: ((matcher matchAt: 1) = 'squeak')].! !

TestCase subclass: #FileChannelLoggerTest
	instanceVariableNames: 'logger testDirectory channel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!FileChannelLoggerTest commentStamp: 'FS 7/17/2008 10:55' prior: 0!
This test creates directory in the image's default directory.!

!FileChannelLoggerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/16/2008 15:47'!
setUp
	testDirectory := FileDirectory default directoryNamed: 'IRC-test-logger'.
	channel :=  '#squeak-test'.
	logger := FileChannelLogger new.
	logger channel: channel.
	logger directory: testDirectory .
	logger initializeStream.! !

!FileChannelLoggerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/16/2008 16:22'!
tearDown
	logger closeStream.
	"testDirectory recursiveDelete.".! !

!FileChannelLoggerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/16/2008 16:16'!
testInitialize
	| dir |
	dir := testDirectory directoryNamed: (channel).
	self assert: (logger dateOfStream = Date today).
	self assert: (logger stream atEnd).
	self assert: (dir exists).! !

!FileChannelLoggerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/24/2008 18:08'!
testLogSimpleMessage
	| msg dir today fileStream |
	today := Date today.
	msg := IRCPrivateMessage 
		sender: 'bob'
		recipient: channel
		text: 'this is a text'.
	logger logSimpleMessage: msg.
	dir := ((testDirectory directoryNamed: channel) directoryNamed: today year asString) directoryNamed: today month name asString.
	self assert: (dir fileExists: today dayOfMonth asString).
	fileStream := dir readOnlyFileNamed: today dayOfMonth asString.
	fileStream contentsOfEntireFile = (logger formatSimpleMessage: msg).
	fileStream close! !

TestCase subclass: #HelpHandlerTest
	instanceVariableNames: 'bot helpHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!HelpHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/9/2008 15:06'!
setUp
	bot := FakeBot new.
	helpHandler := HelpHandler newForBot: bot.! !

!HelpHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/9/2008 15:27'!
testHelpPattern
	| matcher |
	matcher := helpHandler helpPattern.
	self assert: (matcher matches: 'anna, help').
	self assert: (matcher matches: 'Anna, help').
	self assert: (matcher matches: 'Anna,	help'). "tabulation"
	self assert: (matcher matches: 'Anna,  help').
	self assert: (matcher matches: 'anna : help').
	self assert: (matcher matches: 'anna :   help').
	self assert: (matcher matches: 'anna : help admin').
	self assert: (matcher matches: 'anna ; help').
	self deny: (matcher matches: 'brol truc chouette').
	self deny: (matcher matches: 'help').
	self deny: (matcher matches: 'anna blop help').! !

TestCase subclass: #IRCClientConnectionTest
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!IRCClientConnectionTest methodsFor: 'as yet unclassified' stamp: 'FS 7/24/2008 18:42'!
setUp
	client := IRCClientConnection new.! !

!IRCClientConnectionTest methodsFor: 'as yet unclassified' stamp: 'FS 7/24/2008 18:43'!
testInitialize
	self 
		assert: (client socket isNil);
		assert: (client messagesToSend size = 0).! !

!IRCClientConnectionTest methodsFor: 'as yet unclassified' stamp: 'FS 7/28/2008 16:43'!
testMsgRegex
	| r |
	r := client msgRegex.
	self
		assert: (r matches: ':kikoolol.local NOTICE AUTH :*** Looking up your hostname...');
		assert: (( r matchAt: 1) = 'kikoolol.local');
		assert: (( r matchAt: 2) = 'NOTICE AUTH');
		assert: (( r matchAt: 3) = '');
		assert: (( r matchAt: 4) = '*** Looking up your hostname...').
	
	self
		assert: (r matches: ':fstephany!!fstephany@i.love.debian.org PRIVMSG tulipe :Hello!!');
		assert: (( r matchAt: 1) = 'fstephany!!fstephany@i.love.debian.org');
		assert: (( r matchAt: 2) = 'PRIVMSG');
		assert: (( r matchAt: 3) = 'tulipe');
		assert: (( r matchAt: 4) = 'Hello!!').
	self
		assert: (r matches: ':kikoolol.local 421 tulipe /msg :Unknown command');
		assert: (( r matchAt: 1) = 'kikoolol.local');
		assert: (( r matchAt: 2) = '421');
		assert: (( r matchAt: 3) = 'tulipe /msg');
		assert: (( r matchAt: 4) = 'Unknown command').

	self
		assert: (r matches: ':kikoolol.local PONG kikoolol.local :blop');
		assert: (( r matchAt: 2) = 'PONG').

		"this command is the only that has ':' for the text."
	self deny: (r matches: ':kikoolol.local 004 Anna kikoolol.local hybrid-7.2.2.dfsg.2-debian.3 DGabcdfgiklnorsuwxyz biklmnopstveIh bkloveIh').
	self deny: (r matches: 'NOTICE AUTH :*** Looking up your hostname...').! !

!IRCClientConnectionTest methodsFor: 'as yet unclassified' stamp: 'FS 7/28/2008 16:19'!
testMsgRegex2
	| r msg |
	msg := ':fstephany!!n=fstephan@5.194-242-81.adsl-dyn.isp.belgacom.be PRIVMSG squeakbot :admin join'.
	r := client msgRegex.
	self
		assert: (r matches: msg);
		assert: (( r matchAt: 1) = 'fstephany!!n=fstephan@5.194-242-81.adsl-dyn.isp.belgacom.be');
		assert: (( r matchAt: 2) = 'PRIVMSG');
		assert: (( r matchAt: 3) = 'squeakbot');
		assert: (( r matchAt: 4) = 'admin join').
	! !

!IRCClientConnectionTest methodsFor: 'as yet unclassified' stamp: 'FS 7/28/2008 16:44'!
testPingNoticeRegex
	| r |
	r := client msgPingNoticeRegex.
	self
		assert: (r matches: 'NOTICE AUTH :*** Looking up your hostname...');
		assert: (( r matchAt: 1) = 'NOTICE AUTH');
		assert: (( r matchAt: 2) = '*** Looking up your hostname...').
	
	! !

TestCase subclass: #LoggingHandlerTest
	instanceVariableNames: 'handler bot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!LoggingHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/16/2008 21:20'!
setUp
	bot := FakeBot new.
	handler := LoggingHandler new.
	handler bot: bot.
	handler loggerClass: FakeChannelLogger.
	handler initializeLoggerForBot.! !

!LoggingHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/12/2008 21:13'!
testInitialize
	self assert: (handler channelLoggers size = bot channels size).
	self assert: (handler loggerClass = FakeChannelLogger).! !

!LoggingHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/24/2008 18:08'!
testProcessMessage
	| msg1 msg2 msg3 |
	msg1 := IRCPrivateMessage 
		sender: 'bob'
		recipient: '#squeak'
		text: 'message test'.
	msg2 := IRCPrivateMessage 
		sender: 'alice'
		recipient: '#aida'
		text: 'Tililii'.
	msg3 := IRCPrivateMessage 
		sender: 'alice'
		recipient: 'Anna'
		text: 'should not be logged'.
	handler
		processChannelMessage: msg1;
		processChannelMessage: msg2;
		processChannelMessage: msg3.
	self assert: (handler channelLoggers at: '#squeak') messagesLogged size = 1.
	self assert: (handler channelLoggers at: '#aida') messagesLogged size = 1.
	self assert: handler channelLoggers size = bot channels size! !

TestCase subclass: #ReRegexTest
	instanceVariableNames: 'reRegex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!ReRegexTest commentStamp: 'FS 7/7/2008 21:39' prior: 0!
See the ReTest class for a morecomplete testing
!

!ReRegexTest methodsFor: 'as yet unclassified' stamp: 'FS 7/15/2008 16:23'!
testMatchAt
	| p |
	p := ReRegex newForPattern: 'Anna (.*) and (.*)'.	
	self 
		assert: (p matches: 'Anna  and drinks');
		assert: ((p matchAt: 1) = '');	

		assert: (p matches: 'Anna eats and drinks');
		assert: ((p matchAt: 1) = 'eats');
		assert: ((p matchAt: 2) = 'drinks');
		assert: ((p matchAt: 3) = nil);
		deny: (p matches: 'Annaand');
		assert: ((p matchAt: 1) = nil);
		deny: (p matches: 'Anna and drinks'). "only 1 space"! !

!ReRegexTest methodsFor: 'as yet unclassified' stamp: 'FS 7/7/2008 21:37'!
testMatches
	| p |
	p := ReRegex newForPattern: '^Anna'.	
	self 
		assert: (p matches: 'Anna');
		assert: (p matches: 'Anna and you');
		deny: (p matches: 'drink');
		deny: (p matches: 'this is Anna');
		deny: (p matches: 'anna');
		deny: (p matches: 'anna ').
		! !

!ReRegexTest methodsFor: 'as yet unclassified' stamp: 'FS 7/8/2008 11:39'!
testMatchesCaseLess
	| p |
	p := ReRegex newForPattern: '(?i)^Anna'.	
	self 
		assert: (p matches: 'Anna');
		assert: (p matches: 'Anna and you');
		assert: (p matches: 'anna');
		assert: (p matches: 'ANNA');
		assert: (p matches: 'anna blop').
		! !

!ReRegexTest methodsFor: 'as yet unclassified' stamp: 'FS 7/8/2008 11:57'!
testMatchesCaseLess2
	| p |
	p := ReRegex newForPattern: '^Anna'.
	p setCaseInsensitive.
	self 
		assert: (p matches: 'Anna');
		assert: (p matches: 'Anna and you');
		assert: (p matches: 'anna');
		assert: (p matches: 'ANNA');
		assert: (p matches: 'anna blop').
		! !

TestCase subclass: #SocBotTest
	instanceVariableNames: 'localBot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!SocBotTest methodsFor: 'fixtures' stamp: 'FS 7/24/2008 18:08'!
createFakeIRCMessage
	^ IRCPrivateMessage 
		sender: 'fstephany'
		recipient: 'Anna'
		text: 'This is the text'! !

!SocBotTest methodsFor: 'fixtures' stamp: 'FS 6/29/2008 14:41'!
createFakeIRCProtocolMessage
	| message |
	message := IRCProtocolMessage fromString:
		':fstephany!!~fstephany@localhost. PRIVMSG #salonBleu :salut Anna'.
		
	^message! !

!SocBotTest methodsFor: 'fixtures' stamp: 'FS 7/4/2008 22:57'!
setUp
	localBot := SocBot newWithNick: 'Anna'.! !

!SocBotTest methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 01:12'!
testActiveHandlers
	| activeSize |
	activeSize := localBot activeHandlers size. 
	localBot disableHandler: 'HelpHandler'.
	self assert: ( localBot activeHandlers size = (activeSize -1)).
	localBot enableHandler: 'HelpHandler'.
	self assert: ( localBot activeHandlers size = activeSize).! !

!SocBotTest methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 01:14'!
testProcessMessage
	| msg fakeHandler |
	msg := self createFakeIRCMessage.
	localBot handlers: (OrderedCollection new 
		add: (FakeHandler newForBot: localBot);
		yourself).
	
	fakeHandler := localBot findHandler: 'FakeHandler'.
	localBot processPrivateMsg: msg.
	self assert: (fakeHandler messages size = 1).
	
	localBot disableHandler: 'FakeHandler'.
	localBot processPrivateMsg: msg. "this msg shouldnt be forwarded to fakeHandler"
	self assert: (fakeHandler messages size = 1).
	! !
